#include <Cocoa/Cocoa.h>
#include <AlphaBeta/AlphaBeta.h>
#include "PhageState.h"

int main(int argc, char **argv)
{
    NSAutoreleasePool *pool = [NSAutoreleasePool new];
    NSMutableDictionary *opts = [NSMutableDictionary dictionaryWithObjectsAndKeys:
        @"1",           @"--count",
        @"0",           @"--skip",
        @"5",           @"--ply",
        [NSNull null],  @"--time",
        nil];

    if (argc < 3 || !(argc % 2)) {
        fprintf(stderr, "Usage: %s [--opt value]\n", argv[0]);
        return EXIT_FAILURE;
    }
    for (int i = 1; i < argc; i += 2)
        [opts setObject:[NSString stringWithCString:argv[i+1]]
                 forKey:[NSString stringWithCString:argv[i]]];

    SBAlphaBeta *ab = [SBAlphaBeta newWithState:[PhageState new]];

    int skip = [[opts objectForKey:@"--skip"] intValue];
    for (int i = 0; i < skip; i++)
        [ab performMoveFromSearchWithDepth:1];

    int fixed = [[opts objectForKey:@"--time"] isKindOfClass:[NSNull class]];
    int ply = [[opts objectForKey:@"--ply"] intValue];
    for (int i = 0; i < [[opts objectForKey:@"--count"] intValue]; i++) {
        NSDate *date = [NSDate date];
        if (fixed)
            [ab moveFromSearchWithDepth:ply];
        else
            [ab moveFromSearchWithInterval:[[opts objectForKey:@"--time"] doubleValue]];

        printf("%u %lf %u %u (visited/time/ply/skip)\n",
            [ab stateCountForSearch],
            (double)-[date timeIntervalSinceNow],
            fixed ? ply : [ab depthForSearch],
            skip
        );
    }
    
    [pool release];
    return 0;
}
